///
// This file has been generated, if you wish to
// modify it in a permanent way, please refer
// to the script file : gen/generator_cxx.rb
//

int absint(int n){ return (n < 0)?-n:n; }
int signe(int n){ return (n >= 0)? 1: -1; }
const int INFINI = 1000*1000*1000;

#include "prologin.hh"
#include <vector>
#include <algorithm>
#include <cstdio>

bool operator == (const position& a, const position& b){ return a.x == b.x && a.y == b.y; }
bool operator != (const position& a, const position& b){ return !(a == b); }

///
// Fonction appelée au début de la partie.
//
void partie_init()
{
  // fonction a completer
}

struct Action
{
    position portail;
    int nbBoucliers;
    Action(){ portail.x = -1; }
    Action(position p, int n){ portail = p, nbBoucliers = n; }
};

struct Portail  // structure pour choisir et classer les portails suivants possibles
{
    position pos;
    int pertesEnemis;
    int gains;
    int dist;
    int coutAttaque; // mettre la distance divise par 6 dedans
};

bool operator < (const Portail& a, const Portail& b)
{
    return a.dist < b.dist;
}

/*position posPortailGo()
{
    std::vector<position> portails = liste_portails();
    int distMeil = INFINI;
    position posMeil; posMeil.x = -1; posMeil.y = -1;
    for (int i = 0; i < (int)portails.size(); i++)
        if (!case_dans_champ(portails[i]) && portail_joueur(portails[i]) != moi()) {
            int d = absint(portails[i].x-position_agent(moi()).x) + absint(portails[i].y-position_agent(moi()).y);
            if (d < distMeil)
                distMeil = d, posMeil = portails[i];
        }
    return posMeil;
}*/

int choisirNbBoucliers(position pos)
{
    return 1;
}

Action actionFind()
{
    /*std::vector<position> portails = liste_portails();
    int distMeil = INFINI;
    position posMeil; posMeil.x = -1; posMeil.y = -1;
    for (int i = 0; i < (int)portails.size(); i++)
        if (!case_dans_champ(portails[i]) && portail_joueur(portails[i]) != moi()) {
            int d = absint(portails[i].x-position_agent(moi()).x) + absint(portails[i].y-position_agent(moi()).y);
            if (d < distMeil)
                distMeil = d, posMeil = portails[i];
        }
    int nbBoucliers = 1;
    if (posMeil.x != -1)
        if (portail_boucliers(posMeil) > nbBoucliers)
            nbBoucliers = portail_boucliers(posMeil);
    return Action(posMeil, nbBoucliers);*/
    std::vector<position> portails = liste_portails();
    std::vector<Portail> suivants;
    
    for (int i = 0; i < (int)portails.size(); i++)
        if (!case_dans_champ(portails[i]) && portail_joueur(portails[i]) != moi())
        {
            Portail port;
            port.pos = portails[i];
            port.dist = absint(portails[i].x-position_agent(moi()).x) + absint(portails[i].y-position_agent(moi()).y);
            port.coutAttaque = COUT_CAPTURE + port.dist/6;
            if (portail_boucliers(portails[i]) > 0)
                port.coutAttaque += portail_boucliers(portails[i]) * COUT_NEUTRALISATION_BOUCLIER;
            if (portail_joueur(portails[i]) > -1)
                port.coutAttaque += COUT_NEUTRALISATION;
            
            port.pertesEnemis = 0;
            std::vector<champ> champsEnemis = champs_incidents_portail(portails[i]);
            for (int iChamp = 0; iChamp < (int)champsEnemis.size(); iChamp++)
                port.pertesEnemis += score_triangle(champsEnemis[iChamp].som1, champsEnemis[iChamp].som2, champsEnemis[iChamp].som3);
            
            port.gains = POINTS_CAPTURE;
            std::vector<lien> liens = liste_liens();
            for (int iLien = 0; iLien < (int)liens.size(); iLien++)
            {
                lien li = liens[iLien];
                std::vector<lien> coupes = liens_bloquants(portails[i], li.extr1);
                std::vector<lien> coupes2 = liens_bloquants(portails[i], li.extr2);
                for (int a = 0; a < (int)coupes2.size(); a++)
                    coupes.push_back(coupes2[a]);
                bool estCoupe = false;
                
                for (int iCoupe = 0; iCoupe < (int)coupes.size(); iCoupe++)
                    if (coupes[iCoupe].extr1 != portails[i] && coupes[iCoupe].extr2 != portails[i]) {
                        estCoupe = true;
                        break;
                    }
                if (!estCoupe)
                {
                    port.gains += score_triangle(portails[i], li.extr1, li.extr2);
                }
            }
            
            suivants.push_back(port);
            
        }
    
    position posMeil; posMeil.x = -1; posMeil.y = -1;
    int nbBoucliers = 0;
    std::sort(suivants.begin(), suivants.end());
    
    if ((int)suivants.size() > 0)
    {
        int iChoisit = 0;
        posMeil = suivants[iChoisit].pos;
        nbBoucliers = choisirNbBoucliers(posMeil);
    }
    
    return Action(posMeil, nbBoucliers);
    
}

bool termineLiens = true;

bool jouerAction(Action& act, int& nbDeps, int& nbPts)
{
    printf ("je joue une action...");
    position pos = position_agent(moi());
    
    if (act.portail.x == -1)
        return true;
    // go vers ledit lieu
    
    if (pos.x != act.portail.x || pos.y != act.portail.y) // deplacer
    {
        position go = act.portail;
        int dist = absint(go.x-position_agent(moi()).x) + absint(go.y-position_agent(moi()).y);
        
        while (nbDeps < dist && nbPts >= COUT_TURBO) {
            nbDeps++, nbPts -= COUT_TURBO;
            utiliser_turbo();
        }
        
        int depX = std::min(absint(pos.x-go.x), nbDeps) * signe(go.x-pos.x);
        nbDeps -= depX;
        int depY = std::min(absint(pos.y-go.y), nbDeps) * signe(go.y-pos.y);
        nbDeps -= depY;
        
        pos.x += depX; pos.y += depY;
        
        deplacer(pos);
        
        if (pos.x != go.x || pos.y != go.y)
            return false;
    }
    
    // neutraliser
    
    if (portail_joueur(pos) == adversaire())
    {
        int cout = portail_boucliers(pos) * COUT_NEUTRALISATION_BOUCLIER + COUT_NEUTRALISATION;
        if (cout > nbPts)
            return false;
        nbPts -= cout;
        neutraliser();
    }
    
    // capturer
    
    if (COUT_CAPTURE > nbPts)
        return false;
    nbPts -= COUT_CAPTURE;
    capturer();
    
    // creer les liens
    
    std::vector<position> portails = liste_portails();
    for (int i = 0; i < (int)portails.size(); i++)
    {
        erreur e = lier(portails[i]);
        if (e == OK)
            nbPts -= COUT_LIEN;
        if (e == PA_INSUFFISANTS)
            return false;
    }
    
    // creer les boucliers
    
    printf("\n %d boucliers case %d %d\n", act.nbBoucliers, act.portail.x, act.portail.y);
    
    int nbBoucliersPoses = portail_boucliers(pos);
    while (act.nbBoucliers > nbBoucliersPoses)
    {
        printf("acheter un bouclier, il y en a maintenant %d\n", nbBoucliersPoses);
        if (nbPts < COUT_BOUCLIER)
            return false;
        nbPts -= COUT_BOUCLIER;
        ajouter_bouclier();
        nbBoucliersPoses++;
    }
    
    return true;
}

///
// Fonction appelée à chaque tour.
//
Action actAfaire;
void jouer_tour()
{
    
    int nbDeps = NB_POINTS_DEPLACEMENT, nbPts = NB_POINTS_ACTION;
    
    while (jouerAction(actAfaire, nbDeps, nbPts))
    {
        actAfaire = actionFind();
        if (actAfaire.portail.x == -1)
            break;
    }
}

///
// Fonction appelée à la fin de la partie.
//
void partie_fin()
{
  // fonction a completer
}

